org.cpsolver.ifs.model

## Interface WeakeningConstraint<V extends Variable<V,T>,T extends Value<V,T>>

- Type Parameters:
    `V` - Variable
    `T` - Value
  All Known Implementing Classes:
    DepartmentSpreadConstraint, DiscouragedRoomConstraint, JenrlConstraint, MaxBreaksFlexibleConstraint, MaxHolesFlexibleConstraint, MinimizeNumberOfUsedGroupsOfTime, MinimizeNumberOfUsedRoomsConstraint, SpreadConstraint

      public interface WeakeningConstraint<V extends Variable<V,T>,T extends Value<V,T>>

  Interface of a constraint that weakens with the time.
  Version:
    CourseTT 1.3 (University Course Timetabling)
    Copyright (C) 2006 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `weaken(Assignment<V,T> assignment)` Weaken the constraint.
    `void` | `weaken(Assignment<V,T> assignment, T value)` Weaken the constraint enough so that it can assign the given value.

- - ### Method Detail

    - #### weaken

          void weaken(Assignment<V,T> assignment)

      Weaken the constraint. This method is called if the constraint participates in an unassigned of a variable.
      Parameters:
        `assignment` - current assignment

    - #### weaken

          void weaken(Assignment<V,T> assignment,
                      T value)

      Weaken the constraint enough so that it can assign the given value.
      Parameters:
        `assignment` - current assignment
        `value` - a conflicting value to be assigned